diff -ruN qmail-1.03-orig/error.h qmail-1.03-ldap-20060201-orig/error.h
--- qmail-1.03-orig/error.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/error.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,7 +1,7 @@
 #ifndef ERROR_H
 #define ERROR_H
 
-extern int errno;
+#include <errno.h>
 
 extern int error_intr;
 extern int error_nomem;
@@ -16,8 +16,10 @@
 extern int error_pipe;
 extern int error_perm;
 extern int error_acces;
+extern int error_range;
+extern int error_proto;
 
-extern char *error_str();
-extern int error_temp();
+extern const char *error_str(int);
+extern int error_temp(int);
 
 #endif
diff -ruN qmail-1.03-orig/error_str.c qmail-1.03-ldap-20060201-orig/error_str.c
--- qmail-1.03-orig/error_str.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/error_str.c	2006-02-25 11:00:55.000000000 +0100
@@ -3,7 +3,7 @@
 
 #define X(e,s) if (i == e) return s;
 
-char *error_str(i)
+const char *error_str(i)
 int i;
 {
   X(0,"no error")
@@ -20,6 +20,8 @@
   X(error_pipe,"broken pipe")
   X(error_perm,"permission denied")
   X(error_acces,"access denied")
+  X(error_range,"numerical result out of range")
+  X(error_proto,"protocol error")
 #ifdef ESRCH
   X(ESRCH,"no such process")
 #endif
@@ -92,9 +94,6 @@
 #ifdef EDOM
   X(EDOM,"input out of range")
 #endif
-#ifdef ERANGE
-  X(ERANGE,"output out of range")
-#endif
 #ifdef EALREADY
   X(EALREADY,"operation already in progress")
 #endif
@@ -263,9 +262,6 @@
 #ifdef ECOMM
   X(ECOMM,"communication error")
 #endif
-#ifdef EPROTO
-  X(EPROTO,"protocol error")
-#endif
 #ifdef EMULTIHOP
   X(EMULTIHOP,"multihop attempted")
 #endif
diff -ruN qmail-1.03-orig/except.c qmail-1.03-ldap-20060201-orig/except.c
--- qmail-1.03-orig/except.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/except.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "fork.h"
 #include "strerr.h"
 #include "wait.h"
@@ -6,7 +7,7 @@
 
 #define FATAL "except: fatal: "
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -32,6 +33,7 @@
   switch(wait_exitcode(wstat)) {
     case 0: _exit(100);
     case 111: strerr_die2x(111,FATAL,"temporary child error");
-    default: _exit(0);
+    default: break;
   }
+  return 0;
 }
diff -ruN qmail-1.03-orig/execcheck.c qmail-1.03-ldap-20060201-orig/execcheck.c
--- qmail-1.03-orig/execcheck.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/execcheck.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,310 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+
+/*
+ * Code and idea is based on a patch by Russel Nelson.
+ */
+
+#ifdef SMTPEXECCHECK
+#include "byte.h"
+#include "case.h"
+#include "control.h"
+#include "env.h"
+#include "qmail.h"
+#include "str.h"
+#include "stralloc.h"
+
+#include "execcheck.h"
+
+extern void die_nomem(); /* needed error function from qmail-smtpd,c */
+extern void die_control();
+
+static int checkexecutable = 0;
+static int flagexecutable;
+static stralloc signatures = {0};
+
+void
+execcheck_setup(void)
+{
+	if (env_get("REJECTEXEC")) checkexecutable = 1;
+	switch (control_readfile(&signatures,"control/signatures",0)) {
+	case 0:
+		checkexecutable = 0;
+		break;
+	case 1:
+		break;
+	default:
+		die_control();
+	}
+}
+
+int
+execcheck_on(void)
+{
+	return checkexecutable;
+}
+
+int
+execcheck_flag(void)
+{
+	return flagexecutable;
+}
+
+static int
+signatures_match(stralloc *line, char *sig)
+{
+	unsigned int	k;
+
+	for (k = 0; k < line->len && *sig; k++, sig++)
+		if (*sig != '*')
+			if (*sig != line->s[k]) return 0;
+	if (*sig) return 0;
+	return 1;
+}
+
+static int
+signatures_check(stralloc *line)
+{
+	unsigned int	i, j;
+
+	for (i = j = 0; i < signatures.len; i++)
+		if (!signatures.s[i]) {
+			if (signatures_match(line, signatures.s + j))
+				return 1;
+			j = i+1;
+		}
+	return 0;
+}
+
+static int linespastheader;	/* = 0 if in header (mime or mail)
+			 	 * = 1 line after blank line
+				 * = 2 somewhere in body
+				 */
+static unsigned int boundary_start;
+static unsigned int boundary_len;
+static int flagrfc822;
+static char linetype;
+
+static stralloc line = {0};
+static stralloc content = {0};
+static stralloc boundary = {0};
+static stralloc token = {0};
+
+static void
+parse_token(void)
+{
+	if (token.len == 0 || *token.s == '\0')
+		return;
+
+	if (case_startb(token.s, token.len, "boundary=")) {
+		/*
+		 * push the current boundary.
+		 * Append a null and remember start.
+		 */
+		boundary_start = boundary.len;
+		if (!stralloc_cats(&boundary, "--"))
+			die_nomem();
+		if (!stralloc_cats(&boundary, token.s + 9))
+			die_nomem();
+		boundary_len = boundary.len - boundary_start;
+		if (!stralloc_0(&boundary))
+			die_nomem();
+		return;
+	}
+	if (!case_diffb(token.s, token.len, "message/rfc822")) {
+		flagrfc822 = 1;
+		return;
+	}
+}
+
+static void
+parse_contenttype(void)
+{
+	char	*c;
+	int	flagquoted = 0;
+	int	flagcomment = 0;
+
+	if (content.len == 0) /* NO MIME header */
+		return;
+
+	if (!stralloc_0(&content)) die_nomem();
+
+	for (c = content.s; *c != '\0'; ) {
+		for (; *c != '\0'; c++)
+			if (*c != ' ' && *c != '\t' && *c != ';')
+				break;
+
+		if (!stralloc_copys(&token, "")) die_nomem();
+		for (; *c != '\0'; c++)
+			switch (*c) {
+			case ' ':
+			case '\t':
+			case ';':
+				if (flagquoted)
+					break;
+				goto token_done;
+			case '"':
+				if (flagquoted)
+					flagquoted = 0;
+				else
+					flagquoted = 1;
+				break;
+			case '(':
+				if (flagquoted) {
+					if (!stralloc_append(&token, c))
+					       	die_nomem();
+					break;
+				}
+				flagcomment = 1;
+				break;
+			case ')':
+				if (flagquoted) {
+					if (!stralloc_append(&token, c))
+						die_nomem();
+					break;
+				}
+				flagcomment = 0;
+				break;
+			default:
+				if (flagcomment)
+					break;
+				if (!stralloc_append(&token, c)) die_nomem();
+				break;
+			}
+token_done:
+		if (!stralloc_0(&token)) die_nomem();
+		parse_token();
+	}
+}
+
+void
+execcheck_start(void)
+{
+	boundary.len = 0;
+	content.len = 0;
+	linespastheader = 0;
+	boundary_start = 0;
+	boundary_len = 0;
+	flagexecutable = 0;
+	flagrfc822 = 0;
+	linetype = ' ';
+}
+
+void
+execcheck_put(struct qmail *qq, const char *ch)
+{
+	if (!checkexecutable)
+		return;
+
+	/* already bad so leave it */
+	if (flagexecutable)
+		return;
+
+	if (line.len < 1024)
+		if (!stralloc_catb(&line,ch,1)) die_nomem();
+
+	if (*ch != '\n')
+		/* wait until we have a entire line together */
+		return;
+
+	if (linespastheader == 0) {
+		/*
+		 * in mail or mime header, search for content-type
+		 * and possible boundary
+		 */
+		if (line.len == 1) {	/* end of header */
+			linespastheader = 1;
+			if (content.len) /* MIME header */
+				parse_contenttype();
+			if (flagrfc822) {
+				/* now the forwarded rfc822 header is comming */
+				linespastheader = 0;
+				flagrfc822 = 0;
+			}
+		} else {	/* header lines */
+			if (*line.s == ' ' || *line.s == '\t') {
+				switch(linetype) {
+				case 'C':
+					if (!stralloc_catb(&content,
+						    line.s, line.len-1))
+						die_nomem();
+					break;
+				default:
+					break;
+				}
+			} else {
+				if (case_startb(line.s, line.len,
+					    "content-type:")) {
+					if (!stralloc_copyb(&content,
+						    line.s+13, line.len-14))
+						die_nomem();
+					linetype = 'C';
+				} else {
+					linetype = ' ';
+				}
+			}
+		}
+	} else {	/* non-header lines */
+		if (boundary_len && *line.s == '-' &&
+		    stralloc_starts(&line,boundary.s + boundary_start)) {
+			/* mime boundary matched */
+			if (line.len > boundary_len + 2 &&
+			    !str_diffn(line.s + boundary_len, "--", 2)) {
+				/* end marker - pop last boundary */
+				linespastheader = 2;
+				if (boundary_start) {
+					boundary.len = boundary_start;
+					boundary_start = byte_rchr(boundary.s,
+					    boundary.len - 1, '\0');
+					if (boundary_start + 1 >= boundary.len)
+						boundary_start = 0;
+					boundary_len = boundary.len - 1 -
+					    boundary_start;
+				} else
+					boundary_len = 0;
+			} else
+				linespastheader = 0;
+		} else if (linespastheader == 1) {
+			if (signatures_check(&line)) {
+				flagexecutable = 1;
+				qmail_fail(qq);
+			}
+			linespastheader = 2;
+		}
+	}
+	line.len = 0;
+}
+
+#endif
+
diff -ruN qmail-1.03-orig/execcheck.h qmail-1.03-ldap-20060201-orig/execcheck.h
--- qmail-1.03-orig/execcheck.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/execcheck.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef __EXECCHECK_H__
+#define __EXECCHECK_H__
+
+struct qmail;
+
+void execcheck_setup(void);
+void execcheck_start(void);
+int execcheck_on(void);
+int execcheck_flag(void);
+void execcheck_put(struct qmail *, const char *);
+
+#endif
diff -ruN qmail-1.03-orig/exit.h qmail-1.03-ldap-20060201-orig/exit.h
--- qmail-1.03-orig/exit.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/exit.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,6 +1,7 @@
 #ifndef EXIT_H
 #define EXIT_H
 
-extern void _exit();
+/* XXX unistd.h */
+extern void _exit(int);
 
 #endif
diff -ruN qmail-1.03-orig/EXTTODO qmail-1.03-ldap-20060201-orig/EXTTODO
--- qmail-1.03-orig/EXTTODO	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/EXTTODO	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,112 @@
+EXTTODO by Claudio Jeker <jeker@n-r-g.com> and 
+Andre Oppermann <opi@nrg4u.com>
+(c) 2002-2004 Internet Business Solutions Ltd.
+
+The EXTTODO patch is a part of the qmail-ldap patch.
+This patches for qmail come with NO WARRANTY.
+
+RELEASE: 5. Jan. 2003 ($Date: 2004/04/16 13:24:16 $)
+
+EXTTODO:
+======================
+
+TOC:
+ WHAT DOES IT DO
+ INSTALL
+ CONFIG FILES
+ SETUP
+ BIG PICTURE
+
+NEWS:
+ 
+ This is the first release of the EXTTODO patch.
+
+================================================================================
+
+WHAT DOES IT DO
+
+ The exttodo patch addresses a problem known as the silly qmail (queue)
+ problem. This problem is found only on system with high injection rates.
+
+ qmail with a big local and remote concurrency could deliver a tremendous 
+ amount of messages but normally this can not be achieved because qmail-send
+ becomes a bottleneck on those high volumes servers.
+ qmail-send preprocesses all new messages before distributing them for local
+ or remote delivering. In one run qmail-send does one todo run but has the 
+ ability to close multiple jobs. Because of this layout qmail-send can not 
+ feed all the new available (local/remote) delivery slots and therefor it is 
+ not possible to achieve the maximum throughput.
+ This would be a minor problem if one qmail-send run could be done in extreme
+ short time but because of many file system calls (fsync and (un)link) a todo
+ run is expensive and throttles the throughput.
+
+ The exttodo patch tries to solve the problem by moving the todo routine into 
+ an external program. This reduces the run time in qmail-send.
+
+ exttodo adds a new program to qmail called qmail-todo. qmail-todo prepares
+ incoming messages for local and remote delivering (by creating info/<messid>
+ local/<messid> and remote/<messid> and removing todo/<messid>). See also
+ INTERNALS. As next qmail-todo transmits the <messid> to qmail-send which will
+ add this message into the priority queue which schedules the message for 
+ delivery. 
+
+INSTALL
+
+ To enable the exttodo patch you need to define EXTERNAL_TODO while compiling
+ qmail(-ldap) this can be done with the -D flag of cc (e.g. cc -DEXTERNAL_TODO).
+
+ NOTE: the exttodo patch can also be used on qmail systems without the 
+ qmail-ldap patch.
+ 
+================================================================================
+
+CONFIG FILES
+
+ No additional control files are used or needed.
+
+================================================================================
+
+SETUP
+
+ qmail-todo will be started by qmail-start and therefor no additional setup
+ is needed.
+
+ To verify that exttodo is running just check if qmail-todo is running.
+
+================================================================================
+
+BIG PICTURE
+
+               +-------+   +-------+
+               | clean |   | clean |
+               +--0-1--+   +--0-1--+       +-----------+
+         trigger  ^ |         ^ |        +->0,1 lspawn |
+            |     | v         | v       /  +-----------+
+ +-------+  v  +--2-3--+   +--5-6--+   /
+ |       |  |  |       0<--7     1,2<-+
+ | queue |--+--| todo  |   | send  |
+ |       |  |  |       1-->8     3,4<-+
+ +-------+     +-------+   +---0---+   \
+                               |        \  +-----------+
+                               v         +->0,1 rspwan |
+                           +---0---+       +-----------+
+                           | logger|
+                           +-------+
+
+Communication between qmail-send and qmail-todo
+
+todo -> send:
+   D[LRB]<mesgid>\0
+          Start delivery for new message with id <messid>.
+          the character L, R or B defines the type
+          of delivery, local, remote or both respectively.
+   L<string>\0
+          Dump string to the logger without adding additional \n or similar.
+send -> todo:
+   H      Got a SIGHUP reread ~/control/locals and ~/control/virtualdomains
+   X      Quit ASAP.
+
+qmail-todo sends "\0" terminated messages whereas qmail-send just send one
+character to qmail-todo.
+
+
diff -ruN qmail-1.03-orig/fd_copy.c qmail-1.03-ldap-20060201-orig/fd_copy.c
--- qmail-1.03-orig/fd_copy.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/fd_copy.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,4 +1,5 @@
 #include <fcntl.h>
+#include <unistd.h>
 #include "fd.h"
 
 int fd_copy(to,from)
diff -ruN qmail-1.03-orig/fd.h qmail-1.03-ldap-20060201-orig/fd.h
--- qmail-1.03-orig/fd.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/fd.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,7 +1,7 @@
 #ifndef FD_H
 #define FD_H
 
-extern int fd_copy();
-extern int fd_move();
+extern int fd_copy(int, int);
+extern int fd_move(int, int);
 
 #endif
diff -ruN qmail-1.03-orig/fd_move.c qmail-1.03-ldap-20060201-orig/fd_move.c
--- qmail-1.03-orig/fd_move.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/fd_move.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "fd.h"
 
 int fd_move(to,from)
diff -ruN qmail-1.03-orig/fifo.c qmail-1.03-ldap-20060201-orig/fifo.c
--- qmail-1.03-orig/fifo.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/fifo.c	2006-02-25 11:00:55.000000000 +0100
@@ -4,7 +4,7 @@
 #include "fifo.h"
 
 #ifdef HASMKFIFO
-int fifo_make(fn,mode) char *fn; int mode; { return mkfifo(fn,mode); }
+int fifo_make(fn,mode) const char *fn; int mode; { return mkfifo(fn,mode); }
 #else
-int fifo_make(fn,mode) char *fn; int mode; { return mknod(fn,S_IFIFO | mode,0); }
+int fifo_make(fn,mode) const char *fn; int mode; { return mknod(fn,S_IFIFO | mode,0); }
 #endif
diff -ruN qmail-1.03-orig/fifo.h qmail-1.03-ldap-20060201-orig/fifo.h
--- qmail-1.03-orig/fifo.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/fifo.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,6 +1,6 @@
 #ifndef FIFO_H
 #define FIFO_H
 
-extern int fifo_make();
+extern int fifo_make(const char *, int);
 
 #endif
diff -ruN qmail-1.03-orig/FILES qmail-1.03-ldap-20060201-orig/FILES
--- qmail-1.03-orig/FILES	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/FILES	2006-02-25 11:00:55.000000000 +0100
@@ -227,16 +227,11 @@
 case_lowers.c
 case_starts.c
 cdb.3
+cdb.c
 cdb.h
 cdb_hash.c
-cdb_seek.c
-cdb_unpack.c
-cdbmake.h
-cdbmake_add.c
-cdbmake_hash.c
-cdbmake_pack.c
-cdbmss.h
-cdbmss.c
+cdb_make.c
+cdb_make.h
 coe.3
 coe.h
 coe.c
@@ -431,3 +426,105 @@
 tcp-environ.5
 constmap.h
 constmap.c
+EXTTODO
+Makefile.cdb
+POPBEFORESMTP
+QLDAPGROUP
+QLDAPINSTALL
+QLDAPNEWS
+QLDAPPICTURE
+QLDAPTODO
+TLS.readme
+auth_imap.c
+auth_mod.c
+auth_mod.h
+auth_pop.c
+auth_smtp.c
+auto_userl.h
+base64.c
+base64.h
+byte_repl.c
+case_startb.c
+check.c
+check.h
+checkpassword.c
+checkpassword.h
+condwrite.c
+digest.c
+digest_md4.c
+digest_md4.h
+digest_md5.c
+digest_md5.h
+digest_rmd160.c
+digest_rmd160.h
+digest_sha1.c
+digest_sha1.h
+dirmaker
+dirmaker.c
+dirmaker.h
+endian.c
+execcheck.c
+execcheck.h
+localdelivery.c
+localdelivery.h
+locallookup.c
+locallookup.h
+maildir++.c
+maildir++.h
+mailmagic.c
+mailmagic.h
+mailmaker.c
+mailmaker.h
+output.c
+output.h
+passwd.c
+passwd.h
+pbsadd.c
+pbscheck.c
+pbsdbd.c
+pbsexec.c
+pbsexec.h
+popfetch.pl
+qldap-cluster.c
+qldap-cluster.h
+qldap-debug.c
+qldap-debug.h
+qldap-errno.c
+qldap-errno.h
+qldap-filter.c
+qldap-profile.c
+qldap-profile.h
+qldap.c
+qldap.h
+qmail-cdb.c
+qmail-forward.c
+qmail-group.c
+qmail-imapd-ssl.sh
+qmail-imapd.rules
+qmail-imapd.sh
+qmail-ldap.h
+qmail-ldaplookup.c
+qmail-pop3d-ssl.sh
+qmail-pop3d.rules
+qmail-pop3d.sh
+qmail-qmqpd.rules
+qmail-qmqpd.sh
+qmail-quotawarn.c
+qmail-reply.c
+qmail-secretary.c
+qmail-smtpd.rules
+qmail-smtpd.sh
+qmail-todo.c
+qmail-verify.c
+qmail.schema
+qmail.sh
+rbl.c
+rbl.h
+read-ctrl.c
+read-ctrl.h
+readwrite.c
+signatures
+smtpcall.c
+smtpcall.h
+xtext.c
+xtext.h
diff -ruN qmail-1.03-orig/fmt.h qmail-1.03-ldap-20060201-orig/fmt.h
--- qmail-1.03-orig/fmt.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/fmt.h	2006-02-25 11:00:55.000000000 +0100
@@ -4,22 +4,26 @@
 #define FMT_ULONG 40 /* enough space to hold 2^128 - 1 in decimal, plus \0 */
 #define FMT_LEN ((char *) 0) /* convenient abbreviation */
 
-extern unsigned int fmt_uint();
-extern unsigned int fmt_uint0();
+extern unsigned int fmt_uint(char *, unsigned int);
+extern unsigned int fmt_uint0(char *, unsigned int, unsigned int);
+/* XXX not available in qmail-1.03
 extern unsigned int fmt_xint();
 extern unsigned int fmt_nbbint();
 extern unsigned int fmt_ushort();
 extern unsigned int fmt_xshort();
 extern unsigned int fmt_nbbshort();
-extern unsigned int fmt_ulong();
+*/
+extern unsigned int fmt_ulong(char *, unsigned long);
+/* XXX not available in qmail-1.03
 extern unsigned int fmt_xlong();
 extern unsigned int fmt_nbblong();
 
 extern unsigned int fmt_plusminus();
 extern unsigned int fmt_minus();
 extern unsigned int fmt_0x();
+*/
 
-extern unsigned int fmt_str();
-extern unsigned int fmt_strn();
+extern unsigned int fmt_str(char *, const char *);
+extern unsigned int fmt_strn(char *, const char *, unsigned int);
 
 #endif
diff -ruN qmail-1.03-orig/fmtqfn.c qmail-1.03-ldap-20060201-orig/fmtqfn.c
--- qmail-1.03-orig/fmtqfn.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/fmtqfn.c	2006-02-25 11:00:55.000000000 +0100
@@ -4,7 +4,7 @@
 
 unsigned int fmtqfn(s,dirslash,id,flagsplit)
 char *s;
-char *dirslash;
+const char *dirslash;
 unsigned long id;
 int flagsplit;
 {
diff -ruN qmail-1.03-orig/fmtqfn.h qmail-1.03-ldap-20060201-orig/fmtqfn.h
--- qmail-1.03-orig/fmtqfn.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/fmtqfn.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,7 +1,7 @@
 #ifndef FMTQFN_H
 #define FMTQFN_H
 
-extern unsigned int fmtqfn();
+extern unsigned int fmtqfn(char *, const char *, unsigned long, int);
 
 #define FMTQFN 40 /* maximum space needed, if len(dirslash) <= 10 */
 
diff -ruN qmail-1.03-orig/fmt_str.c qmail-1.03-ldap-20060201-orig/fmt_str.c
--- qmail-1.03-orig/fmt_str.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/fmt_str.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,12 +1,12 @@
 #include "fmt.h"
 
 unsigned int fmt_str(s,t)
-register char *s; register char *t;
+register char *s; register const char *t;
 {
   register unsigned int len;
   char ch;
   len = 0;
-  if (s) { while (ch = t[len]) s[len++] = ch; }
+  if (s) { while ((ch = t[len])) s[len++] = ch; }
   else while (t[len]) len++;
   return len;
 }
diff -ruN qmail-1.03-orig/fmt_strn.c qmail-1.03-ldap-20060201-orig/fmt_strn.c
--- qmail-1.03-orig/fmt_strn.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/fmt_strn.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,7 +1,7 @@
 #include "fmt.h"
 
 unsigned int fmt_strn(s,t,n)
-register char *s; register char *t; register unsigned int n;
+register char *s; register const char *t; register unsigned int n;
 {
   register unsigned int len;
   char ch;
diff -ruN qmail-1.03-orig/fork.h1 qmail-1.03-ldap-20060201-orig/fork.h1
--- qmail-1.03-orig/fork.h1	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/fork.h1	2006-02-25 11:00:55.000000000 +0100
@@ -1,7 +1,8 @@
 #ifndef FORK_H
 #define FORK_H
 
-extern int fork();
+#include <unistd.h>
+
 #define vfork fork
 
 #endif
diff -ruN qmail-1.03-orig/fork.h2 qmail-1.03-ldap-20060201-orig/fork.h2
--- qmail-1.03-orig/fork.h2	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/fork.h2	2006-02-25 11:00:55.000000000 +0100
@@ -1,7 +1,6 @@
 #ifndef FORK_H
 #define FORK_H
 
-extern int fork();
-extern int vfork();
+#include <unistd.h>
 
 #endif
diff -ruN qmail-1.03-orig/forward.c qmail-1.03-ldap-20060201-orig/forward.c
--- qmail-1.03-orig/forward.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/forward.c	2006-02-25 11:00:55.000000000 +0100
@@ -13,7 +13,7 @@
 
 struct qmail qqt;
 
-int mywrite(fd,buf,len) int fd; char *buf; int len;
+int mywrite(int fd, void *buf, int len)
 {
   qmail_put(&qqt,buf,len);
   return len;
@@ -21,18 +21,18 @@
 
 char inbuf[SUBSTDIO_INSIZE];
 char outbuf[1];
-substdio ssin = SUBSTDIO_FDBUF(read,0,inbuf,sizeof inbuf);
+substdio ssin = SUBSTDIO_FDBUF(subread,0,inbuf,sizeof inbuf);
 substdio ssout = SUBSTDIO_FDBUF(mywrite,-1,outbuf,sizeof outbuf);
 
 char num[FMT_ULONG];
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
   char *sender;
   char *dtline;
-  char *qqx;
+  const char *qqx;
  
   sig_pipeignore();
  
@@ -57,4 +57,5 @@
   qqx = qmail_close(&qqt);
   if (*qqx) strerr_die2x(*qqx == 'D' ? 100 : 111,FATAL,qqx + 1);
   strerr_die2x(0,"forward: qp ",num);
+  return 0;
 }
diff -ruN qmail-1.03-orig/gen_allocdefs.h qmail-1.03-ldap-20060201-orig/gen_allocdefs.h
--- qmail-1.03-orig/gen_allocdefs.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/gen_allocdefs.h	2006-02-25 11:00:55.000000000 +0100
@@ -8,7 +8,7 @@
     i = x->a; \
     if (n > i) { \
       x->a = base + n + (n >> 3); \
-      if (alloc_re(&x->field,i * sizeof(type),x->a * sizeof(type))) return 1; \
+      if (alloc_re((char **)&x->field,i * sizeof(type),x->a * sizeof(type))) return 1; \
       x->a = i; return 0; } \
     return 1; } \
   x->len = 0; \
@@ -21,7 +21,7 @@
     i = x->a; n += x->len; \
     if (n > i) { \
       x->a = base + n + (n >> 3); \
-      if (alloc_re(&x->field,i * sizeof(type),x->a * sizeof(type))) return 1; \
+      if (alloc_re((char **)&x->field,i * sizeof(type),x->a * sizeof(type))) return 1; \
       x->a = i; return 0; } \
     return 1; } \
   x->len = 0; \
diff -ruN qmail-1.03-orig/getln2.c qmail-1.03-ldap-20060201-orig/getln2.c
--- qmail-1.03-orig/getln2.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/getln2.c	2006-02-25 11:00:55.000000000 +0100
@@ -23,7 +23,11 @@
     if (n == 0) { *clen = 0; return 0; }
     x = substdio_PEEK(ss);
     i = byte_chr(x,n,sep);
-    if (i < n) { substdio_SEEK(ss,*clen = i + 1); *cont = x; return 0; }
+    if (i < (unsigned int)n) {
+      substdio_SEEK(ss,*clen = i + 1);
+      *cont = x;
+      return 0;
+    }
     if (!stralloc_readyplus(sa,n)) return -1;
     i = sa->len;
     sa->len = i + substdio_get(ss,sa->s + i,n);
diff -ruN qmail-1.03-orig/getln.h qmail-1.03-ldap-20060201-orig/getln.h
--- qmail-1.03-orig/getln.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/getln.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,7 +1,10 @@
 #ifndef GETLN_H
 #define GETLN_H
 
-extern int getln();
-extern int getln2();
+#include "stralloc.h"
+#include "substdio.h"
+
+extern int getln(substdio *, stralloc *, int *, int);
+extern int getln2(substdio *, stralloc *, char **, unsigned int *, int);
 
 #endif
diff -ruN qmail-1.03-orig/gettimeofday.c qmail-1.03-ldap-20060201-orig/gettimeofday.c
--- qmail-1.03-orig/gettimeofday.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/gettimeofday.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,13 @@
+#include   <stdio.h>
+#include   <sys/time.h>
+
+struct timeval sincepoch = {0,0};
+struct timezone notimezone = {0,0};
+
+int main()
+{
+  gettimeofday(&sincepoch, &notimezone);
+  printf("%d\n", sincepoch.tv_sec);
+  return 0;
+}
+
diff -ruN qmail-1.03-orig/gfrom.h qmail-1.03-ldap-20060201-orig/gfrom.h
--- qmail-1.03-orig/gfrom.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/gfrom.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,6 +1,6 @@
 #ifndef GFROM_H
 #define GFROM_H
 
-extern int gfrom();
+extern int gfrom(char *, int);
 
 #endif
diff -ruN qmail-1.03-orig/headerbody.h qmail-1.03-ldap-20060201-orig/headerbody.h
--- qmail-1.03-orig/headerbody.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/headerbody.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,6 +1,10 @@
 #ifndef HEADERBODY_H
 #define HEADERBODY_H
 
-extern int headerbody();
+#include "stralloc.h"
+#include "substdio.h"
+
+extern int headerbody(substdio *,
+    void (*)(stralloc *), void (*)(void), void (*)(stralloc *));
 
 #endif
diff -ruN qmail-1.03-orig/hfield.c qmail-1.03-ldap-20060201-orig/hfield.c
--- qmail-1.03-orig/hfield.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/hfield.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,6 +1,6 @@
 #include "hfield.h"
 
-static char *(hname[]) = {
+static const char *(hname[]) = {
   "unknown-header"
 , "sender"
 , "from"
@@ -35,13 +35,13 @@
 
 static int hmatch(s,len,t)
 char *s;
-int len;
-char *t;
+unsigned int len;
+const char *t;
 {
- int i;
+ unsigned int i;
  char ch;
 
- for (i = 0;ch = t[i];++i)
+ for (i = 0;(ch = t[i]);++i)
   {
    if (i >= len) return 0;
    if (ch != s[i])
@@ -62,12 +62,12 @@
 
 int hfield_known(s,len)
 char *s;
-int len;
+unsigned int len;
 {
- int i;
- char *t;
+ unsigned int i;
+ const char *t;
 
- for (i = 1;t = hname[i];++i)
+ for (i = 1;(t = hname[i]);++i)
    if (hmatch(s,len,t))
      return i;
  return 0;
@@ -75,10 +75,10 @@
 
 int hfield_valid(s,len)
 char *s;
-int len;
+unsigned int len;
 {
- int i;
- int j;
+ unsigned int i;
+ unsigned int j;
  char ch;
 
  for (j = 0;j < len;++j)
@@ -105,9 +105,9 @@
 
 unsigned int hfield_skipname(s,len)
 char *s;
-int len;
+unsigned int len;
 {
- int i;
+ unsigned int i;
  char ch;
 
  for (i = 0;i < len;++i)
diff -ruN qmail-1.03-orig/hfield.h qmail-1.03-ldap-20060201-orig/hfield.h
--- qmail-1.03-orig/hfield.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/hfield.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,9 +1,9 @@
 #ifndef HFIELD_H
 #define HFIELD_H
 
-extern unsigned int hfield_skipname();
-extern int hfield_known();
-extern int hfield_valid();
+extern unsigned int hfield_skipname(char *, unsigned int);
+extern int hfield_known(char *, unsigned int);
+extern int hfield_valid(char *, unsigned int);
 
 #define H_SENDER 1
 #define H_FROM 2
